
Redmine - Patch #40008

Replace String#sub with delete_prefix / delete_suffix

2024-01-06 01:03 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 6.0.0   

Description

The attached patch replaces `String#sub` which is used to remove leading or trailing substring with String#delete_prefix and

String#delete_suffix introduced in Ruby 2.5.

The change improves the efficiency and readability of the code.

ruby 3.2.2 (2023-03-30 revision e51014f9c0) [arm64-darwin22]

Warming up --------------------------------------

'#123'.delete_prefix('#')

                         1.497M i/100ms

'#123'.sub('^#', '')   936.977k i/100ms

Calculating -------------------------------------

'#123'.delete_prefix('#')

                         14.822M (± 0.5%) i/s -     74.837M in   5.049042s

'#123'.sub('^#', '')      9.322M (± 1.2%) i/s -     46.849M in   5.026072s

Comparison:

'#123'.delete_prefix('#'): 14822395.1 i/s

'#123'.sub('^#', ''):  9322431.1 i/s - 1.59x  slower

Associated revisions

Revision 22596 - 2024-01-08 02:04 - Go MAEDA

Replace String#sub with delete_prefix / delete_suffix (#40008).

Patch by Go MAEDA (@maeda).

Revision 22597 - 2024-01-08 02:14 - Go MAEDA

Refactor CustomFieldsControllerTest#custom_field_classes (#40008).

Revision 22598 - 2024-01-08 02:39 - Go MAEDA

Refactor file extension removal in Theme#assets to use File.basename instead of delete_suffix (#40008).

History

#1 - 2024-01-06 07:03 - Go MAEDA

- File delete-prefix-suffix-v2.patch added

#2 - 2024-01-08 02:15 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch in r22596.

Files

delete-prefix-suffix.patch 6.09 KB 2024-01-06 Go MAEDA

delete-prefix-suffix-v2.patch 9.63 KB 2024-01-06 Go MAEDA
